﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Net;
using System.Net.Sockets;
using System.Net.Mail;
using System.ComponentModel;
using System.Net.Mime;
using System.Threading;

namespace luento15
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
// huom. kaikissa seuraavissa pitäisi napata SocketExceptionit kiinni!
        private void buttonURL_Click(object sender, RoutedEventArgs e)
        {
            // muuntaa domainin ip-osoitteeksi
            textBlockTulos.Text = "";          

            IPHostEntry nimi;
            nimi = Dns.GetHostEntry(textBoxURL.Text);

            foreach (IPAddress ip in nimi.AddressList)
                textBlockTulos.Text += ip.ToString() + "\n";
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                textBlockTulos.Text = Dns.GetHostName();
            }
            catch (SocketException error) { 
                // jotain koneen verkkoasetuksissa on pielessä
                MessageBox.Show(error.ToString());
            }
        
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
                    // gethostentry == resolve
            IPHostEntry nimi = Dns.GetHostEntry(textBoxURL.Text);
            textBlockTulos.Text = nimi.HostName;
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
//            IPHostEntry osoite = Dns.Resolve(textBoxURL.Text);
            IPHostEntry osoite = Dns.GetHostEntry(textBoxURL.Text);

            textBlockTulos.Text = osoite.HostName + "\n";

            foreach (IPAddress ip in osoite.AddressList)
                textBlockTulos.Text += ip.ToString() + "\n";

        }
// lähetetään sähköpostia
        private void button4_Click(object sender, RoutedEventArgs e)
        {
            MailAddress from = new MailAddress("tjlahton@mit.jyu.fi", "Tommi Lahtonen", System.Text.Encoding.GetEncoding(1252)) ;
//            MailAddress from = new MailAddress("tjlahton@mit.jyu.fi", "Tommi Lahtonen", System.Text.Encoding.UTF8);
            MailAddress to = new MailAddress("tommi.j.lahtonen@jyu.fi", "Lammi Tohtonen");
            MailMessage message = new MailMessage(from, to);

            message.Subject = ".NET-kokeilu";
            message.Body = "Kokeilen toimiiko sähköpostin lähettäminen";
            message.BodyEncoding = System.Text.Encoding.GetEncoding(1252); // windows-1252 eli iso-8859-1

            Attachment firstAttachment = new Attachment("c:\\mytemp\\testi.txt", MediaTypeNames.Text.Plain);
//            Attachment firstAttachment = new Attachment("c:\\mytemp\foobar.pdlqw", MediaTypeNames.Application.Octet); // jos tyyppi ei ole tiedossa
            message.Attachments.Add(firstAttachment);

            MailAddress To = new MailAddress("tjlahton@mit.jyu.fi");
            message.To.Add(To);
            MailAddress copy = new MailAddress("foo@bar.example");
            message.CC.Add(copy);
            MailAddress blindcopy = new MailAddress("foo@bar.invalid");
            message.Bcc.Add(copy);


            SmtpClient client = new SmtpClient("smtp.jyu.fi");
//            SmtpClient client = new SmtpClient(); // ilman parametria pitäisi etsiä automaattisesti palvelimen mutta riippunee koneesta/käyttöjärjestelmästä

            try
            {
                client.Send(message);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }

        }
        private static void Lahetetty(object sender, AsyncCompletedEventArgs e)
        {
            // Get the unique identifier for this asynchronous operation.
            String token = (string)e.UserState;

            if (e.Cancelled)
            {
                MessageBox.Show("Lähettäminen peruttu");
                return;
            }
            if (e.Error != null)
            {
                MessageBox.Show("Lähetysvirhe: " + token + " " + e.Error.ToString());
                return;
            }
            MessageBox.Show("Viesti lähetetty");
        }

        private void button5_Click(object sender, RoutedEventArgs e)
        {
            MailAddress from = new MailAddress("foobar@foo.example", "Tommi Lahtonen", System.Text.Encoding.GetEncoding(1252));
            MailAddress to = new MailAddress("tommi.j.lahtonen@jyu.fi", "Lammi Tohtonen");
            MailMessage message = new MailMessage(from, to);

            message.Subject = ".NET-kokeilu";
            message.Body = "Kokeilen toimiiko sähköpostin lähettäminen";

            MailAddress To = new MailAddress("tjlahton@mit.jyu.fi");
            message.To.Add(To);
            MailAddress copy = new MailAddress("foo@bar.example");
            message.CC.Add(copy);
            MailAddress blindcopy = new MailAddress("foo@bar.invalid");
            message.Bcc.Add(copy);

            SmtpClient client = new SmtpClient("smtp.jyu.fi");

            client.SendCompleted += new SendCompletedEventHandler(Lahetetty);
            string userState = "test message1"; // voi olla mitä tahansa
            client.SendAsync(message, userState);


        }

        // huono synkroninen palvelin
        private void button6_Click(object sender, RoutedEventArgs e)
        {
            // merkkijono pitää muuttaa tavuiksi
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            Byte[] message = encoding.GetBytes("Moro!");
//            textBlockTulos.Text = "";
            try
            {
                IPAddress localAddress = IPAddress.Parse("127.0.0.1");
                TcpListener listener = new TcpListener(localAddress, 2200);
                listener.Start(1);  // enintään yksi yhteys voi jonottaa
                while (true)
                    {
                    textBlockTulos.Text += "Palvelin odottaa socket " + listener.LocalEndpoint + "\n";
 
                   TcpClient client = listener.AcceptTcpClient();
 
                    NetworkStream io = client.GetStream();

                    textBlockTulos.Text += "Saatu yhteys: " + client.Client.RemoteEndPoint + "\n";
                    textBlockTulos.Text += "Lähetetään viesti\n";
 
                    io.Write(message, 0, message.Length);

                    textBlockTulos.Text += "Suljetaan yhteys\n";
                    client.Close();
                }
            }
            catch (Exception error)
            {
                MessageBox.Show(error.ToString());
            }

        }


        private void button7_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                IPAddress localAddress = IPAddress.Parse("127.0.0.1");
                TcpListener listener = new TcpListener(localAddress, 2200);
                listener.Start(); // voi muodostua jonoa
//                string state = "testiyhteys1";
                listener.BeginAcceptTcpClient(new AsyncCallback(ReceiveCallback), listener );
            }
            catch (Exception error)
            {
                MessageBox.Show(error.ToString());
            }


        }
        NetworkStream stream;
        public void ReceiveCallback(IAsyncResult Ar)
        {

            TcpListener listener = (TcpListener)Ar.AsyncState;
            TcpClient client = (TcpClient)listener.EndAcceptTcpClient(Ar);
            //            textBlockTulos.Text += "Yhteys on avattu" + "\n";
            MessageBox.Show("yhteys on avattu");
            stream = client.GetStream();

            if (stream.CanWrite)
            {
                System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
                Byte[] message = encoding.GetBytes("Yhteys on nyt avattu!");
                stream.Write(message, 0, message.Length);
            }
            if (stream.CanRead)
            {

                byte[] myReadBuffer = new byte[1024];
                stream.BeginRead(myReadBuffer, 0, myReadBuffer.Length,
                                                             new AsyncCallback(myReadCallBack),
                                                             stream);

            }
            listener.BeginAcceptTcpClient(new AsyncCallback(ReceiveCallback), listener);
        }
        string buffer = "";

        public void myReadCallBack(IAsyncResult Ar) {

            NetworkStream stream = (NetworkStream)Ar.AsyncState;
            byte[] myReadBuffer = new byte[1024];
            stream.Read(myReadBuffer, 0, myReadBuffer.Length);
            buffer += System.Text.Encoding.ASCII.GetString(myReadBuffer, 0, myReadBuffer.Length);
            // this.Title = buffer;
            //            MessageBox.Show(buffer);
            buffer = "";
            stream.Write(myReadBuffer, 0, myReadBuffer.Length);

/*            int rivi = buffer.IndexOf("\n");
                if (rivi > 0)
                {
                    string apu = buffer.Substring(0, rivi);
                    buffer = buffer.Substring(rivi+1);
                    MessageBox.Show(apu);
                    stream.Write(myReadBuffer, 0, myReadBuffer.Length);
                }
*/

            stream.BeginRead(myReadBuffer, 0, myReadBuffer.Length, new
                AsyncCallback(myReadCallBack),
                stream);

        }

        TcpClient asiakas;
        private void button8_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                IPAddress localAddress = IPAddress.Parse("127.0.0.1");
                asiakas = new TcpClient();
                asiakas.Connect(localAddress, 2200);
                NetworkStream st = asiakas.GetStream();
                byte[] myReadBuffer = new byte[100];
                st.Read(myReadBuffer, 0, myReadBuffer.Length);
                MessageBox.Show( System.Text.Encoding.ASCII.GetString(myReadBuffer, 0, myReadBuffer.Length));
            }
            catch (Exception error)
            {
                MessageBox.Show(error.ToString());
            }
        }

        private void button9_Click(object sender, RoutedEventArgs e)
        {
            NetworkStream st = asiakas.GetStream();
//            byte[] myReadBuffer = new byte[100];
//            st.Read(myReadBuffer, 0, myReadBuffer.Length);
//            textBlockTulos.Text += System.Text.Encoding.ASCII.GetString(myReadBuffer, 0, myReadBuffer.Length);
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            byte[] sendBuffer = encoding.GetBytes(textBoxLaheta.Text);
            st.Write(sendBuffer, 0, sendBuffer.Length  );

        }

    }
}
